Subject: Re: [PATCH] vduse: implement DMA sync callbacks

From: Christoph Hellwig <[email-masked]>
Date: Fri, 23 Feb 2024 00:03:01 -0800

On Thu, Feb 22, 2024 at 03:29:10PM -0500, Michael S. Tsirkin wrote:
> In a sense ... but on the other hand, the "fake DMA" metaphor seems to
> work surprisingly well, like in this instance - internal bounce buffer
> looks a bit like non-coherent DMA.  A way to make this all prettier
> would I guess be to actually wrap all of DMA with virtio wrappers which
> would all go if () dma_... else vduse_...; or something to this end.  A
> lot of work for sure, and is it really worth it? if the only crazy
> driver is vduse I'd maybe rather keep the crazy hacks local there ...

Well, vduse is the only driver that does this hack - we had a few more
and we got rid of it.  It basically is the only thing preventing us
from doing direct calls into the iommu code and compile out dma_ops
entirely for non-Xen builds on the common architectures.

So yes, I'd really like to see it gone rather sooner than later.